summaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorYann Collet <cyan@fb.com>2016-11-17 21:02:06 (GMT)
committerYann Collet <cyan@fb.com>2016-11-17 21:02:06 (GMT)
commit1abecbc33c8ec5b84d2623dcbe73136aeb99db37 (patch)
tree398361394772160cd31cbc2b496d4814484fcb10 /tests
parent7fde7438d39f8452f89e3fee5ba4a16c502dffb0 (diff)
downloadlz4-1abecbc33c8ec5b84d2623dcbe73136aeb99db37.zip
lz4-1abecbc33c8ec5b84d2623dcbe73136aeb99db37.tar.gz
lz4-1abecbc33c8ec5b84d2623dcbe73136aeb99db37.tar.bz2
fix 32-bits mode.
Large File support for Mac OS-X in 32-bits mode Fixed potential undefined behavior Changed makefile for 32-bits mode
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile222
-rw-r--r--tests/fullbench.c63
-rw-r--r--tests/fuzzer.c15
3 files changed, 120 insertions, 180 deletions
diff --git a/tests/Makefile b/tests/Makefile
index 4e96769..4b0f503 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -23,21 +23,18 @@
# - LZ4 source repository : https://github.com/lz4/lz4
# ##########################################################################
# fuzzer : Test tool, to check lz4 integrity on target platform
-# fuzzer32: Same as fuzzer, but forced to compile in 32-bits mode
# frametest : Test tool, to check lz4frame integrity on target platform
-# frametest32: Same as frametest, but forced to compile in 32-bits mode
# fullbench : Precisely measure speed for each LZ4 function variant
-# fullbench32: Same as fullbench, but forced to compile in 32-bits mode
# datagen : generates synthetic data samples for tests & benchmarks
# ##########################################################################
DESTDIR ?=
PREFIX ?= /usr/local
-VOID := /dev/null
BINDIR := $(PREFIX)/bin
MANDIR := $(PREFIX)/share/man/man1
-LZ4DIR := ../lib
+LIBDIR := ../lib
PRGDIR := ../programs
+VOID := /dev/null
TESTDIR := versionsTest
PYTHON ?= python3
@@ -46,8 +43,8 @@ CFLAGS += -Wall -Wextra -Wundef -Wcast-qual -Wcast-align -Wshadow -Wswitch-enum
-Wdeclaration-after-statement -Wstrict-prototypes \
-Wpointer-arith -Wstrict-aliasing=1
CFLAGS += $(MOREFLAGS)
-CPPFLAGS:= -I$(LZ4DIR) -DXXH_NAMESPACE=LZ4_
-FLAGS := $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
+CPPFLAGS:= -I$(LIBDIR) -DXXH_NAMESPACE=LZ4_
+FLAGS = $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
# Define *.exe as extension for Windows systems
@@ -56,6 +53,7 @@ EXT =.exe
else
EXT =
endif
+LZ4 := $(PRGDIR)/lz4$(EXT)
# Default test parameters
@@ -64,58 +62,48 @@ FUZZER_TIME := -T3mn
NB_LOOPS ?= -i1
-default: native
-
-m32: fullbench32 fuzzer32 frametest32
-
-native: fullbench fuzzer frametest datagen fasttest
+default: all
-all: native m32
+all: fullbench fuzzer frametest datagen fasttest
+all32: CFLAGS+=-m32
+all32: all
lz4:
- $(MAKE) -C $(PRGDIR) $@
+ $(MAKE) -C $(PRGDIR) clean $@ CFLAGS="$(CFLAGS)"
lz4c:
- $(MAKE) -C $(PRGDIR) $@
+ $(MAKE) -C $(PRGDIR) clean $@ CFLAGS="$(CFLAGS)"
-lz4c32:
- $(MAKE) -C $(PRGDIR) $@
+lz4c32: # create a 32-bits version for 32/64 interop tests
+ $(MAKE) -C $(PRGDIR) clean $@ CFLAGS="-m32 $(CFLAGS)"
+ cp $(LZ4) $(LZ4)c32
-fullbench : $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/lz4frame.o $(LZ4DIR)/xxhash.o fullbench.c
+fullbench : $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/lz4frame.o $(LIBDIR)/xxhash.o fullbench.c
$(CC) $(FLAGS) $^ -o $@$(EXT)
-fullbench32: $(LZ4DIR)/lz4.c $(LZ4DIR)/lz4hc.c $(LZ4DIR)/lz4frame.c $(LZ4DIR)/xxhash.c fullbench.c
- $(CC) -m32 $(FLAGS) $^ -o $@$(EXT)
+fullbench-lib: fullbench.c $(LIBDIR)/xxhash.c
+ $(MAKE) -C $(LIBDIR) liblz4.a
+ $(CC) $(FLAGS) $^ -o $@$(EXT) $(LIBDIR)/liblz4.a
-fullbench-lib: fullbench.c $(LZ4DIR)/xxhash.c
- $(MAKE) -C $(LZ4DIR) liblz4.a
- $(CC) $(FLAGS) $^ -o $@$(EXT) $(LZ4DIR)/liblz4.a
+fullbench-dll: fullbench.c $(LIBDIR)/xxhash.c
+ $(MAKE) -C $(LIBDIR) liblz4
+ $(CC) $(FLAGS) $^ -o $@$(EXT) -DLZ4_DLL_IMPORT=1 $(LIBDIR)/dll/liblz4.dll
-fullbench-dll: fullbench.c $(LZ4DIR)/xxhash.c
- $(MAKE) -C $(LZ4DIR) liblz4
- $(CC) $(FLAGS) $^ -o $@$(EXT) -DLZ4_DLL_IMPORT=1 $(LZ4DIR)/dll/liblz4.dll
-
-fuzzer : $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/xxhash.o fuzzer.c
+fuzzer : $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/xxhash.o fuzzer.c
$(CC) $(FLAGS) $^ -o $@$(EXT)
-fuzzer32: $(LZ4DIR)/lz4.c $(LZ4DIR)/lz4hc.c $(LZ4DIR)/xxhash.c fuzzer.c
- $(CC) -m32 $(FLAGS) $^ -o $@$(EXT)
-
-frametest: $(LZ4DIR)/lz4frame.o $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/xxhash.o frametest.c
+frametest: $(LIBDIR)/lz4frame.o $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/xxhash.o frametest.c
$(CC) $(FLAGS) $^ -o $@$(EXT)
-frametest32: $(LZ4DIR)/lz4frame.c $(LZ4DIR)/lz4.c $(LZ4DIR)/lz4hc.c $(LZ4DIR)/xxhash.c frametest.c
- $(CC) -m32 $(FLAGS) $^ -o $@$(EXT)
-
-fasttest: $(LZ4DIR)/lz4.o fasttest.c
+fasttest: $(LIBDIR)/lz4.o fasttest.c
$(CC) $(FLAGS) $^ -o $@$(EXT)
datagen : $(PRGDIR)/datagen.c datagencli.c
$(CC) $(FLAGS) -I$(PRGDIR) $^ -o $@$(EXT)
clean:
- @$(MAKE) -C $(LZ4DIR) $@ > $(VOID)
+ @$(MAKE) -C $(LIBDIR) $@ > $(VOID)
@$(RM) core *.o *.test tmp* \
fullbench-dll$(EXT) fullbench-lib$(EXT) \
fullbench$(EXT) fullbench32$(EXT) \
@@ -134,40 +122,44 @@ versionsTest:
#FreeBSD targets
ifneq (,$(filter $(shell uname),Linux Darwin GNU/kFreeBSD GNU FreeBSD))
-test: test-lz4 test-lz4c test-fasttest test-frametest test-fullbench test-fuzzer
+MD5:=md5sum
+ifneq (,$(filter $(shell uname), Darwin ))
+MD5:=md5 -r
+endif
-test32: test-lz4c32 test-frametest32 test-fullbench32 test-fuzzer32
+test: test-lz4 test-lz4c test-fasttest test-frametest test-fullbench test-fuzzer
-test-all: test test32
+test32: CFLAGS+=-m32
+test32: test
test-lz4-sparse: lz4 datagen
@echo "\n ---- test sparse file support ----"
./datagen -g5M -P100 > tmpSrc
- $(PRGDIR)/lz4 -B4D tmpSrc | $(PRGDIR)/lz4 -dv --sparse > tmpB4
+ $(LZ4) -B4D tmpSrc | $(LZ4) -dv --sparse > tmpB4
diff -s tmpSrc tmpB4
- $(PRGDIR)/lz4 -B5D tmpSrc | $(PRGDIR)/lz4 -dv --sparse > tmpB5
+ $(LZ4) -B5D tmpSrc | $(LZ4) -dv --sparse > tmpB5
diff -s tmpSrc tmpB5
- $(PRGDIR)/lz4 -B6D tmpSrc | $(PRGDIR)/lz4 -dv --sparse > tmpB6
+ $(LZ4) -B6D tmpSrc | $(LZ4) -dv --sparse > tmpB6
diff -s tmpSrc tmpB6
- $(PRGDIR)/lz4 -B7D tmpSrc | $(PRGDIR)/lz4 -dv --sparse > tmpB7
+ $(LZ4) -B7D tmpSrc | $(LZ4) -dv --sparse > tmpB7
diff -s tmpSrc tmpB7
- $(PRGDIR)/lz4 tmpSrc | $(PRGDIR)/lz4 -dv --no-sparse > tmpNoSparse
+ $(LZ4) tmpSrc | $(LZ4) -dv --no-sparse > tmpNoSparse
diff -s tmpSrc tmpNoSparse
ls -ls tmp*
- ./datagen -s1 -g1200007 -P100 | $(PRGDIR)/lz4 | $(PRGDIR)/lz4 -dv --sparse > tmpOdd # Odd size file (to generate non-full last block)
+ ./datagen -s1 -g1200007 -P100 | $(LZ4) | $(LZ4) -dv --sparse > tmpOdd # Odd size file (to generate non-full last block)
./datagen -s1 -g1200007 -P100 | diff -s - tmpOdd
ls -ls tmpOdd
@$(RM) tmp*
@echo "\n Compatibility with Console :"
- echo "Hello World 1 !" | $(PRGDIR)/lz4 | $(PRGDIR)/lz4 -d -c
- echo "Hello World 2 !" | $(PRGDIR)/lz4 | $(PRGDIR)/lz4 -d | cat
- echo "Hello World 3 !" | $(PRGDIR)/lz4 --no-frame-crc | $(PRGDIR)/lz4 -d -c
+ echo "Hello World 1 !" | $(LZ4) | $(LZ4) -d -c
+ echo "Hello World 2 !" | $(LZ4) | $(LZ4) -d | cat
+ echo "Hello World 3 !" | $(LZ4) --no-frame-crc | $(LZ4) -d -c
@echo "\n Compatibility with Append :"
./datagen -P100 -g1M > tmp1M
cat tmp1M tmp1M > tmp2M
- $(PRGDIR)/lz4 -B5 -v tmp1M tmpC
- $(PRGDIR)/lz4 -d -v tmpC tmpR
- $(PRGDIR)/lz4 -d -v tmpC >> tmpR
+ $(LZ4) -B5 -v tmp1M tmpC
+ $(LZ4) -d -v tmpC tmpR
+ $(LZ4) -d -v tmpC >> tmpR
ls -ls tmp*
diff tmp2M tmpR
@$(RM) tmp*
@@ -175,14 +167,15 @@ test-lz4-sparse: lz4 datagen
test-lz4-contentSize: lz4 datagen
@echo "\n ---- test original size support ----"
./datagen -g15M > tmp
- $(PRGDIR)/lz4 -v tmp | $(PRGDIR)/lz4 -t
- $(PRGDIR)/lz4 -v --content-size tmp | $(PRGDIR)/lz4 -d > tmp2
+ $(LZ4) -v tmp | $(LZ4) -t
+ $(LZ4) -v --content-size tmp | $(LZ4) -d > tmp2
diff -s tmp tmp2
# test large size [2-4] GB
- @./datagen -g3G -P100 | $(PRGDIR)/lz4 | $(PRGDIR)/lz4 --decompress --force --sparse - tmp
+ @./datagen -g3G -P100 | $(LZ4) --verbose | $(LZ4) --decompress --force --sparse - tmp
@ls -ls tmp
- $(PRGDIR)/lz4 --quiet --content-size tmp | $(PRGDIR)/lz4 --verbose --decompress --force --sparse - tmp2
+ @./datagen -g3G -P100 | $(LZ4) --quiet --content-size | $(LZ4) --verbose --decompress --force --sparse - tmp2
@ls -ls tmp2
+ diff -s tmp tmp2
@$(RM) tmp*
test-lz4-frame-concatenation: lz4 datagen
@@ -190,10 +183,10 @@ test-lz4-frame-concatenation: lz4 datagen
@echo -n > empty.test
@echo hi > nonempty.test
cat nonempty.test empty.test nonempty.test > orig.test
- @$(PRGDIR)/lz4 -zq empty.test > empty.lz4.test
- @$(PRGDIR)/lz4 -zq nonempty.test > nonempty.lz4.test
+ @$(LZ4) -zq empty.test > empty.lz4.test
+ @$(LZ4) -zq nonempty.test > nonempty.lz4.test
cat nonempty.lz4.test empty.lz4.test nonempty.lz4.test > concat.lz4.test
- $(PRGDIR)/lz4 -d concat.lz4.test > result.test
+ $(LZ4) -d concat.lz4.test > result.test
sdiff orig.test result.test
@$(RM) *.test
@echo frame concatenation test completed
@@ -203,54 +196,54 @@ test-lz4-multiple: lz4 datagen
@./datagen -s1 > tmp1 2> $(VOID)
@./datagen -s2 -g100K > tmp2 2> $(VOID)
@./datagen -s3 -g1M > tmp3 2> $(VOID)
- $(PRGDIR)/lz4 -f -m tmp*
+ $(LZ4) -f -m tmp*
ls -ls tmp*
@$(RM) tmp1 tmp2 tmp3
- $(PRGDIR)/lz4 -df -m *.lz4
+ $(LZ4) -df -m *.lz4
ls -ls tmp*
- $(PRGDIR)/lz4 -f -m tmp1 notHere tmp2; echo $$?
+ $(LZ4) -f -m tmp1 notHere tmp2; echo $$?
@$(RM) tmp*
test-lz4-basic: lz4 datagen
@echo "\n ---- test lz4 basic compression/decompression ----"
- ./datagen -g0 | $(PRGDIR)/lz4 -v | $(PRGDIR)/lz4 -t
- ./datagen -g16KB | $(PRGDIR)/lz4 -9 | $(PRGDIR)/lz4 -t
+ ./datagen -g0 | $(LZ4) -v | $(LZ4) -t
+ ./datagen -g16KB | $(LZ4) -9 | $(LZ4) -t
./datagen -g20KB > tmpSrc
- $(PRGDIR)/lz4 < tmpSrc | $(PRGDIR)/lz4 -d > tmpRes
+ $(LZ4) < tmpSrc | $(LZ4) -d > tmpRes
diff -q tmpSrc tmpRes
- $(PRGDIR)/lz4 --no-frame-crc < tmpSrc | $(PRGDIR)/lz4 -d > tmpRes
+ $(LZ4) --no-frame-crc < tmpSrc | $(LZ4) -d > tmpRes
diff -q tmpSrc tmpRes
- ./datagen | $(PRGDIR)/lz4 | $(PRGDIR)/lz4 -t
- ./datagen -g6M -P99 | $(PRGDIR)/lz4 -9BD | $(PRGDIR)/lz4 -t
- ./datagen -g17M | $(PRGDIR)/lz4 -9v | $(PRGDIR)/lz4 -qt
- ./datagen -g33M | $(PRGDIR)/lz4 --no-frame-crc | $(PRGDIR)/lz4 -t
- ./datagen -g256MB | $(PRGDIR)/lz4 -vqB4D | $(PRGDIR)/lz4 -t
+ ./datagen | $(LZ4) | $(LZ4) -t
+ ./datagen -g6M -P99 | $(LZ4) -9BD | $(LZ4) -t
+ ./datagen -g17M | $(LZ4) -9v | $(LZ4) -qt
+ ./datagen -g33M | $(LZ4) --no-frame-crc | $(LZ4) -t
+ ./datagen -g256MB | $(LZ4) -vqB4D | $(LZ4) -t
@$(RM) tmp*
test-lz4-hugefile: lz4 datagen
@echo "\n ---- test huge files compression/decompression ----"
- ./datagen -g6GB | $(PRGDIR)/lz4 -vB5D | $(PRGDIR)/lz4 -qt
- ./datagen -g6GB | $(PRGDIR)/lz4 -v5BD | $(PRGDIR)/lz4 -qt
+ ./datagen -g6GB | $(LZ4) -vB5D | $(LZ4) -qt
+ ./datagen -g6GB | $(LZ4) -v5BD | $(LZ4) -qt
@$(RM) tmp*
test-lz4-testmode: lz4 datagen
@echo "\n ---- bench mode ----"
- $(PRGDIR)/lz4 -bi1
+ $(LZ4) -bi1
@echo "\n ---- test mode ----"
- ./datagen | $(PRGDIR)/lz4 -t && false || true
- ./datagen | $(PRGDIR)/lz4 -tf && false || true
+ ./datagen | $(LZ4) -t && false || true
+ ./datagen | $(LZ4) -tf && false || true
@echo "\n ---- pass-through mode ----"
- ./datagen | $(PRGDIR)/lz4 -d > $(VOID) && false || true
- ./datagen | $(PRGDIR)/lz4 -df > $(VOID)
+ ./datagen | $(LZ4) -d > $(VOID) && false || true
+ ./datagen | $(LZ4) -df > $(VOID)
@echo "Hello World !" > tmp1
- $(PRGDIR)/lz4 -dcf tmp1
+ $(LZ4) -dcf tmp1
@echo "from underground..." > tmp2
- $(PRGDIR)/lz4 -dcfm tmp1 tmp2
+ $(LZ4) -dcfm tmp1 tmp2
@echo "\n ---- test cli ----"
- $(PRGDIR)/lz4 file-does-not-exist && false || true
- $(PRGDIR)/lz4 -f file-does-not-exist && false || true
- $(PRGDIR)/lz4 -fm file1-dne file2-dne && false || true
- $(PRGDIR)/lz4 -fm file1-dne file2-dne && false || true
+ $(LZ4) file-does-not-exist && false || true
+ $(LZ4) -f file-does-not-exist && false || true
+ $(LZ4) -fm file1-dne file2-dne && false || true
+ $(LZ4) -fm file1-dne file2-dne && false || true
test-lz4: lz4 datagen test-lz4-basic test-lz4-multiple test-lz4-sparse \
test-lz4-frame-concatenation test-lz4-testmode test-lz4-contentSize \
@@ -258,53 +251,54 @@ test-lz4: lz4 datagen test-lz4-basic test-lz4-multiple test-lz4-sparse \
test-lz4c: lz4c datagen
@echo "\n ---- test lz4c version ----"
- ./datagen -g256MB | $(PRGDIR)/lz4c -l -v | $(PRGDIR)/lz4c -t
+ ./datagen -g256MB | $(LZ4)c -l -v | $(LZ4)c -t
+
+test-lz4c32: CFLAGS+=-m32
+test-lz4c32: test-lz4
test-interop-32-64: lz4 lz4c32 datagen
@echo "\n ---- test interoperability 32-bits -vs- 64 bits ----"
- ./datagen -g16KB | $(PRGDIR)/lz4c32 -9 | $(PRGDIR)/lz4 -t
- ./datagen -P10 | $(PRGDIR)/lz4 -9B4 | $(PRGDIR)/lz4c32 -t
- ./datagen | $(PRGDIR)/lz4c32 | $(PRGDIR)/lz4 -t
- ./datagen -g1M | $(PRGDIR)/lz4 -3B5 | $(PRGDIR)/lz4c32 -t
- ./datagen -g256MB | $(PRGDIR)/lz4c32 -vqB4D | $(PRGDIR)/lz4 -qt
- ./datagen -g1G -P90 | $(PRGDIR)/lz4 | $(PRGDIR)/lz4c32 -t
- ./datagen -g6GB | $(PRGDIR)/lz4c32 -vq9BD | $(PRGDIR)/lz4 -qt
+ ./datagen -g16KB | $(LZ4)c32 -9 | $(LZ4) -t
+ ./datagen -P10 | $(LZ4) -9B4 | $(LZ4)c32 -t
+ ./datagen | $(LZ4)c32 | $(LZ4) -t
+ ./datagen -g1M | $(LZ4) -3B5 | $(LZ4)c32 -t
+ ./datagen -g256MB | $(LZ4)c32 -vqB4D | $(LZ4) -qt
+ ./datagen -g1G -P90 | $(LZ4) | $(LZ4)c32 -t
+ ./datagen -g6GB | $(LZ4)c32 -vq9BD | $(LZ4) -qt
test-lz4c32-basic: lz4c32 datagen
@echo "\n ---- test lz4c32 32-bits version ----"
- ./datagen -g16KB | $(PRGDIR)/lz4c32 -9 | $(PRGDIR)/lz4c32 -t
- ./datagen | $(PRGDIR)/lz4c32 | $(PRGDIR)/lz4c32 -t
- ./datagen -g256MB | $(PRGDIR)/lz4c32 -vqB4D | $(PRGDIR)/lz4c32 -qt
- ./datagen -g6GB | $(PRGDIR)/lz4c32 -vqB5D | $(PRGDIR)/lz4c32 -qt
+ ./datagen -g16KB | $(LZ4)c32 -9 | $(LZ4)c32 -t
+ ./datagen | $(LZ4)c32 | $(LZ4)c32 -t
+ ./datagen -g256MB | $(LZ4)c32 -vqB4D | $(LZ4)c32 -qt
+ ./datagen -g6GB | $(LZ4)c32 -vqB5D | $(LZ4)c32 -qt
test-platform:
@echo "\n ---- test lz4 $(QEMU_SYS) platform ----"
- $(QEMU_SYS) ./datagen -g16KB | $(QEMU_SYS) $(PRGDIR)/lz4 -9 | $(QEMU_SYS) $(PRGDIR)/lz4 -t
- $(QEMU_SYS) ./datagen | $(QEMU_SYS) $(PRGDIR)/lz4 | $(QEMU_SYS) $(PRGDIR)/lz4 -t
- $(QEMU_SYS) ./datagen -g256MB | $(QEMU_SYS) $(PRGDIR)/lz4 -vqB4D | $(QEMU_SYS) $(PRGDIR)/lz4 -qt
+ $(QEMU_SYS) ./datagen -g16KB | $(QEMU_SYS) $(LZ4) -9 | $(QEMU_SYS) $(LZ4) -t
+ $(QEMU_SYS) ./datagen | $(QEMU_SYS) $(LZ4) | $(QEMU_SYS) $(LZ4) -t
+ $(QEMU_SYS) ./datagen -g256MB | $(QEMU_SYS) $(LZ4) -vqB4D | $(QEMU_SYS) $(LZ4) -qt
ifneq ($(QEMU_SYS),qemu-arm-static)
- $(QEMU_SYS) ./datagen -g3GB | $(QEMU_SYS) $(PRGDIR)/lz4 -vqB5D | $(QEMU_SYS) $(PRGDIR)/lz4 -qt
+ $(QEMU_SYS) ./datagen -g3GB | $(QEMU_SYS) $(LZ4) -vqB5D | $(QEMU_SYS) $(LZ4) -qt
endif
-test-lz4c32: test-lz4c32-basic test-interop-32-64
-
test-fullbench: fullbench
./fullbench --no-prompt $(NB_LOOPS) $(TEST_FILES)
-test-fullbench32: fullbench32
- ./fullbench32 --no-prompt $(NB_LOOPS) $(TEST_FILES)
+test-fullbench32: CFLAGS += -m32
+test-fullbench32: test-fullbench
test-fuzzer: fuzzer
./fuzzer $(FUZZER_TIME)
-test-fuzzer32: fuzzer32
- ./fuzzer32 $(FUZZER_TIME)
+test-fuzzer32: CFLAGS += -m32
+test-fuzzer32: test-fuzzer
test-frametest: frametest
./frametest $(FUZZER_TIME)
-test-frametest32: frametest32
- ./frametest32 $(FUZZER_TIME)
+test-frametest32: CFLAGS += -m32
+test-frametest32: test-frametest
test-fasttest: fasttest
./fasttest
@@ -313,17 +307,17 @@ test-mem: lz4 datagen fuzzer frametest fullbench
@echo "\n ---- valgrind tests : memory analyzer ----"
valgrind --leak-check=yes --error-exitcode=1 ./datagen -g50M > $(VOID)
./datagen -g16KB > tmp
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 -9 -BD -f tmp $(VOID)
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) -9 -BD -f tmp $(VOID)
./datagen -g16KB -s2 > tmp2
./datagen -g16KB -s3 > tmp3
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 --force --multiple tmp tmp2 tmp3
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) --force --multiple tmp tmp2 tmp3
./datagen -g16MB > tmp
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 -9 -B5D -f tmp tmp2
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 -t tmp2
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 -bi1 tmp
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) -9 -B5D -f tmp tmp2
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) -t tmp2
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) -bi1 tmp
valgrind --leak-check=yes --error-exitcode=1 ./fullbench -i1 tmp tmp2
./datagen -g256MB > tmp
- valgrind --leak-check=yes --error-exitcode=1 $(PRGDIR)/lz4 -B4D -f -vq tmp $(VOID)
+ valgrind --leak-check=yes --error-exitcode=1 $(LZ4) -B4D -f -vq tmp $(VOID)
$(RM) tmp*
valgrind --leak-check=yes --error-exitcode=1 ./fuzzer -i64 -t1
valgrind --leak-check=yes --error-exitcode=1 ./frametest -i256
diff --git a/tests/fullbench.c b/tests/fullbench.c
index 1cac1e0..03dfe19 100644
--- a/tests/fullbench.c
+++ b/tests/fullbench.c
@@ -229,16 +229,6 @@ static int local_LZ4_saveDict(const char* in, char* out, int inSize)
return LZ4_saveDict(&LZ4_stream, out, inSize);
}
-static int local_LZ4_compress_default(const char* in, char* out, int inSize)
-{
- return LZ4_compress_default(in, out, inSize, LZ4_compressBound(inSize));
-}
-
-static int local_LZ4_compress_limitedOutput(const char* in, char* out, int inSize)
-{
- return LZ4_compress_default(in, out, inSize, LZ4_compressBound(inSize)-1);
-}
-
static int local_LZ4_compress_default_large(const char* in, char* out, int inSize)
{
return LZ4_compress_default(in, out, inSize, LZ4_compressBound(inSize));
@@ -279,26 +269,6 @@ static int local_LZ4_compress_fast_continue0(const char* in, char* out, int inSi
return LZ4_compress_fast_continue(&LZ4_stream, in, out, inSize, LZ4_compressBound(inSize), 0);
}
-static int local_LZ4_compress_withState(const char* in, char* out, int inSize)
-{
- return LZ4_compress_fast_extState(&LZ4_stream, in, out, inSize, LZ4_compressBound(inSize), 1);
-}
-
-static int local_LZ4_compress_limitedOutput_withState(const char* in, char* out, int inSize)
-{
- return LZ4_compress_fast_extState(&LZ4_stream, in, out, inSize, LZ4_compressBound(inSize)-1, 1);
-}
-
-static int local_LZ4_compress_continue(const char* in, char* out, int inSize)
-{
- return LZ4_compress_fast_continue(&LZ4_stream, in, out, inSize, LZ4_compressBound(inSize), 1);
-}
-
-static int local_LZ4_compress_limitedOutput_continue(const char* in, char* out, int inSize)
-{
- return LZ4_compress_fast_continue(&LZ4_stream, in, out, inSize, LZ4_compressBound(inSize)-1, 1);
-}
-
#ifndef LZ4_DLL_IMPORT
/* declare hidden function */
int LZ4_compress_forceExtDict (LZ4_stream_t* LZ4_stream, const char* source, char* dest, int inputSize);
@@ -328,31 +298,16 @@ static int local_LZ4_compress_HC(const char* in, char* out, int inSize)
return LZ4_compress_HC(in, out, inSize, LZ4_compressBound(inSize), 9);
}
-static int local_LZ4_compressHC_withStateHC(const char* in, char* out, int inSize)
+static int local_LZ4_compress_HC_extStateHC(const char* in, char* out, int inSize)
{
return LZ4_compress_HC_extStateHC(&LZ4_streamHC, in, out, inSize, LZ4_compressBound(inSize), 9);
}
-static int local_LZ4_compressHC_limitedOutput_withStateHC(const char* in, char* out, int inSize)
-{
- return LZ4_compress_HC_extStateHC(&LZ4_streamHC, in, out, inSize, LZ4_compressBound(inSize)-1, 9);
-}
-
-static int local_LZ4_compressHC_limitedOutput(const char* in, char* out, int inSize)
-{
- return LZ4_compress_HC(in, out, inSize, LZ4_compressBound(inSize)-1, 9);
-}
-
-static int local_LZ4_compressHC_continue(const char* in, char* out, int inSize)
+static int local_LZ4_compress_HC_continue(const char* in, char* out, int inSize)
{
return LZ4_compress_HC_continue(&LZ4_streamHC, in, out, inSize, LZ4_compressBound(inSize));
}
-static int local_LZ4_compressHC_limitedOutput_continue(const char* in, char* out, int inSize)
-{
- return LZ4_compress_HC_continue(&LZ4_streamHC, in, out, inSize, LZ4_compressBound(inSize)-1);
-}
-
/* decompression functions */
static int local_LZ4_decompress_fast(const char* in, char* out, int inSize, int outSize)
@@ -530,11 +485,8 @@ int fullSpeedBench(const char** fileNamesTable, int nbFiles)
case 8 : compressionFunction = local_LZ4_compress_fast_continue0; initFunction = local_LZ4_createStream; compressorName = "LZ4_compress_fast_continue(0)"; break;
case 10: compressionFunction = local_LZ4_compress_HC; compressorName = "LZ4_compress_HC"; break;
- case 11: compressionFunction = local_LZ4_compressHC_limitedOutput; compressorName = "LZ4_compressHC_limitedOutput"; break;
- case 12 : compressionFunction = local_LZ4_compressHC_withStateHC; compressorName = "LZ4_compressHC_withStateHC"; break;
- case 13: compressionFunction = local_LZ4_compressHC_limitedOutput_withStateHC; compressorName = "LZ4_compressHC_limitedOutput_withStateHC"; break;
- case 14: compressionFunction = local_LZ4_compressHC_continue; initFunction = local_LZ4_resetStreamHC; compressorName = "LZ4_compressHC_continue"; break;
- case 15: compressionFunction = local_LZ4_compressHC_limitedOutput_continue; initFunction = local_LZ4_resetStreamHC; compressorName = "LZ4_compressHC_limitedOutput_continue"; break;
+ case 12: compressionFunction = local_LZ4_compress_HC_extStateHC; compressorName = "LZ4_compress_HC_extStateHC"; break;
+ case 14: compressionFunction = local_LZ4_compress_HC_continue; initFunction = local_LZ4_resetStreamHC; compressorName = "LZ4_compress_HC_continue"; break;
#ifndef LZ4_DLL_IMPORT
case 20: compressionFunction = local_LZ4_compress_forceDict; initFunction = local_LZ4_resetDictT; compressorName = "LZ4_compress_forceDict"; break;
#endif
@@ -549,13 +501,6 @@ int fullSpeedBench(const char** fileNamesTable, int nbFiles)
if (chunkP[0].origSize < 8) { DISPLAY(" cannot bench %s with less then 8 bytes \n", compressorName); continue; }
LZ4_loadDictHC(&LZ4_streamHC, chunkP[0].origBuffer, chunkP[0].origSize);
break;
- case 60: DISPLAY("Obsolete compression functions : \n"); continue;
- case 61: compressionFunction = local_LZ4_compress_default; compressorName = "LZ4_compress_default"; break;
- case 62: compressionFunction = local_LZ4_compress_limitedOutput; compressorName = "LZ4_compress_limitedOutput"; break;
- case 63: compressionFunction = local_LZ4_compress_withState; compressorName = "LZ4_compress_withState"; break;
- case 64: compressionFunction = local_LZ4_compress_limitedOutput_withState; compressorName = "LZ4_compress_limitedOutput_withState"; break;
- case 65: compressionFunction = local_LZ4_compress_continue; initFunction = local_LZ4_createStream; compressorName = "LZ4_compress_continue"; break;
- case 66: compressionFunction = local_LZ4_compress_limitedOutput_continue; initFunction = local_LZ4_createStream; compressorName = "LZ4_compress_limitedOutput_continue"; break;
default :
continue; /* unknown ID : just skip */
}
diff --git a/tests/fuzzer.c b/tests/fuzzer.c
index 301b01a..06cfd40 100644
--- a/tests/fuzzer.c
+++ b/tests/fuzzer.c
@@ -170,7 +170,7 @@ static void FUZ_fillCompressibleNoiseBuffer(void* buffer, size_t bufferSize, dou
static int FUZ_AddressOverflow(void)
{
char* buffers[MAX_NB_BUFF_I134+1];
- int i, nbBuff=0;
+ int nbBuff=0;
int highAddress = 0;
DISPLAY("Overflow tests : ");
@@ -185,12 +185,13 @@ static int FUZ_AddressOverflow(void)
buffers[0] = (char*)malloc(BLOCKSIZE_I134);
buffers[1] = (char*)malloc(BLOCKSIZE_I134);
if ((!buffers[0]) || (!buffers[1])) {
+ free(buffers[0]); free(buffers[1]);
DISPLAY("not enough memory for tests \n");
return 0;
}
for (nbBuff=2; nbBuff < MAX_NB_BUFF_I134; nbBuff++) {
- DISPLAY("%3i \b\b\b\b", nbBuff);
+ DISPLAY("%3i \b\b\b\b", nbBuff); fflush(stdout);
buffers[nbBuff] = (char*)malloc(BLOCKSIZE_I134);
if (buffers[nbBuff]==NULL) goto _endOfTests;
@@ -201,7 +202,7 @@ static int FUZ_AddressOverflow(void)
}
{ size_t const sizeToGenerateOverflow = (size_t)(- ((uintptr_t)buffers[nbBuff-1]) + 512);
- int const nbOf255 = (int)((sizeToGenerateOverflow / 255) + 1);
+ unsigned const nbOf255 = (unsigned)((sizeToGenerateOverflow / 255) + 1);
char* const input = buffers[nbBuff-1];
char* output = buffers[nbBuff];
int r;
@@ -209,15 +210,15 @@ static int FUZ_AddressOverflow(void)
input[1] = (char)0xFF;
input[2] = (char)0xFF;
input[3] = (char)0xFF;
- for(i = 4; i <= nbOf255+4; i++) input[i] = (char)0xff;
+ { unsigned u; for(u = 4; u <= nbOf255+4; u++) input[u] = (char)0xff; }
r = LZ4_decompress_safe(input, output, nbOf255+64, BLOCKSIZE_I134);
- if (r>0) goto _overflowError;
+ if (r>0) { DISPLAY("LZ4_decompress_safe = %i \n", r); goto _overflowError; }
input[0] = (char)0x1F; /* Match length overflow */
input[1] = (char)0x01;
input[2] = (char)0x01;
input[3] = (char)0x00;
r = LZ4_decompress_safe(input, output, nbOf255+64, BLOCKSIZE_I134);
- if (r>0) goto _overflowError;
+ if (r>0) { DISPLAY("LZ4_decompress_safe = %i \n", r); goto _overflowError; }
output = buffers[nbBuff-2]; /* Reverse in/out pointer order */
input[0] = (char)0xF0; /* Literal length overflow */
@@ -237,7 +238,7 @@ static int FUZ_AddressOverflow(void)
nbBuff++;
_endOfTests:
- for (i=0 ; i<nbBuff; i++) free(buffers[i]);
+ { int i; for (i=0 ; i<nbBuff; i++) free(buffers[i]); }
if (!highAddress) DISPLAY("high address not possible \n");
else DISPLAY("all overflows correctly detected \n");
return 0;